' ----------------------------------------------------------------
' BIFROST* ENGINE DEMO - converted to Boriel's ZX BASIC Compiler
'
' This program can be compiled as follows:
'
' zxb.exe bifrostdem.bas -T -B
'
' After compiling it, use the following loader to execute:
'
' 10 CLEAR 32767
' 20 LOAD "TILES"CODE
' 30 LOAD "BIFROST*"CODE
' 40 LOAD "bifrostdem"CODE
' 50 RANDOMIZE USR 32768
'
' This sample was purposely implemented in "old BASIC style",
' thus even people familiar with classic Sinclair BASIC (but
' not familiar with Boriel's ZX BASIC) will understand it.
'
' Original version and further information is available at
' http://www.worldofspectrum.org/infoseekid.cgi?id=0027405
' ----------------------------------------------------------------
#include "bifrost.bas"

  20 INK 5: PAPER 0: BORDER 0: CLS: RANDOMIZE
  30 PRINT INK 6;AT 4,22;"BIFROST*";AT 5,23;"ENGINE";AT 6,24;"DEMO"; INK 4; AT 10,24;"WITH";AT 11,23;"BORIEL";AT 12,22;"ZX-BASIC"
  40 BIFROSTstart()
  50 FOR r=0 TO 8: FOR c=0 TO 8
     BIFROSTsetTile(r, c, BIFROSTSTATIC + r*9+c)
     NEXT c: NEXT r
  60 GO SUB 210
  70 PRINT AT 20,1;"Demonstrating static tiles"
  80 FOR r=0 TO 8: FOR c=0 TO 8
     BIFROSTsetTile(r, c, BIFROSTSTATIC + INT(RND*26)+8)
     NEXT c: NEXT r
  90 GO SUB 210
 100 PRINT AT 20,1;"Animated tiles (4 frames)",
 110 GO SUB 220
 120 PRINT AT 20,17;"2"
 130 BIFROSTresetAnim2Frames()
 140 GO SUB 220
 150 BIFROSTresetAnim4Frames()
 160 PRINT AT 20,1;"Directly modifying areas",
 170 BIFROSTsetTile(4, 4, BIFROSTDISABLED)
     BIFROSTsetTile(4, 5, BIFROSTDISABLED)
 180 PRINT AT 9,9;"BIFR";AT 10,9;"OST*"
 190 FOR c=1 TO 4: LET x=INT (RND*8): FOR b=0 TO 1: FOR f=8+72+0 TO 8+72+15: FOR g=9 TO 12
     POKE BIFROSTfindAttrH(f, g),x+(x*7 & (b=0))
     LET x=x+1-(5 & (x=7))
     NEXT g: NEXT f: NEXT b: NEXT c
 200 GO TO 60
 210 PRINT AT 22,1;INK 7;"PRESS ANY KEY": IF INKEY$="" THEN GO TO 210
     ELSE PRINT AT 22,1,,: RETURN
     END IF
 220 FOR f=0 TO 50
     BIFROSTsetTile(INT (RND*9), INT (RND*9), INT (RND*8))
     NEXT f
 230 PRINT AT 22,1;INK 7;"CHOOSE SPEED 2-4 OR 0 TO EXIT"
 240 LET a$=INKEY$
 250 IF a$="2" THEN BIFROSTresetAnimSlow(): PRINT AT 20,25;" slow)": END IF
 260 IF a$="4" THEN BIFROSTresetAnimFast(): PRINT AT 20,25;" fast)": END IF
 270 IF a$<>"0" THEN GO TO 240: END IF
 280 PRINT AT 22,1,,: RETURN
